Index: /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestServiceTest.java
===================================================================
--- /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestServiceTest.java	(revision 5549)
+++ /ComponentRegistry/trunk/ComponentRegistry/src/test/java/clarin/cmdi/componentregistry/rest/ComponentRegistryRestServiceTest.java	(revision 5550)
@@ -926,151 +977,156 @@
     @Test
     public void testRegisterUserspaceProfile() throws Exception {
-        
+
+        System.out.println("testRegisterUserspacProfile");
+
         fillUpPrivateItems();
         fillUpPublicItems();
-        
-	List<ProfileDescription> profiles = getUserProfiles();
-	assertEquals("user registered profiles", 1, profiles.size());
-	assertEquals("public registered profiles", 2, getPublicProfiles()
-		.size());
-	FormDataMultiPart form = createFormData(RegistryTestHelper
-		.getTestProfileContent());
-	RegisterResponse response = getAuthenticatedResource(getResource().path("/registry/profiles")).type(
-		MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
-		form);
-	assertTrue(response.isProfile());
-	assertTrue(response.isInUserSpace());
-	ProfileDescription profileDesc = (ProfileDescription) response
-		.getDescription();
-	assertNotNull(profileDesc);
-	assertEquals("Test1", profileDesc.getName());
-	assertEquals("My Test", profileDesc.getDescription());
-	assertEquals(expectedUserId("JUnit@test.com"), profileDesc.getUserId());
-	assertEquals("Database test user", profileDesc.getCreatorName());
-	assertTrue(profileDesc.getId().startsWith(
-		ComponentRegistry.REGISTRY_ID + "p_"));
-	assertNotNull(profileDesc.getRegistrationDate());
-	assertEquals(
-		"http://localhost:9998/registry/profiles/"
-			+ profileDesc.getId(),
-		profileDesc.getHref());
-
-	profiles = getUserProfiles();
-	assertEquals(2, profiles.size());
-	assertEquals(2, getPublicProfiles().size());
-
-	// Try to post unauthenticated
-	ClientResponse cResponse = getResource().path("/registry/profiles")
-		.type(MediaType.MULTIPART_FORM_DATA)
-		.post(ClientResponse.class, form);
-	assertEquals(401, cResponse.getStatus());
-
-	
-	
-	CMDComponentSpec spec = getAuthenticatedResource(getResource().path("/registry/profiles/" + profileDesc.getId())
-			.queryParam(REGISTRY_SPACE_PARAM, "private")).accept(
-		MediaType.APPLICATION_XML).get(CMDComponentSpec.class);
-	assertNotNull(spec);
-
-	cResponse = this.getAuthenticatedResource(getResource()
-		.path("/registry/profiles/" + profileDesc.getId() + "/xsd"))
-		.accept(MediaType.TEXT_XML).get(ClientResponse.class);
-	assertEquals(200, cResponse.getStatus());
-	String profile = cResponse.getEntity(String.class);
-	assertTrue(profile.length() > 0);
-
-	profile = getAuthenticatedResource(getResource().path(
-			"/registry/profiles/" + profileDesc.getId() + "/xml"))
-		.accept(MediaType.TEXT_XML).get(String.class);
-	assertTrue(profile.length() > 0);
-
-	cResponse = getAuthenticatedResource(getResource().path("/registry/profiles/" + profileDesc.getId())
-			.queryParam(REGISTRY_SPACE_PARAM, "private")).delete(
-		ClientResponse.class);
-	assertEquals(200, cResponse.getStatus());
-
-	profiles = getUserProfiles();
-	assertEquals(1, profiles.size());
+
+        List<ProfileDescription> profiles = getUserProfiles();
+        assertEquals("user registered profiles", 1, profiles.size());
+        assertEquals("public registered profiles", 2, getPublicProfiles()
+                .size());
+        FormDataMultiPart form = createFormData(RegistryTestHelper
+                .getTestProfileContent());
+        RegisterResponse response = getAuthenticatedResource(getResource().path("/registry/profiles")).type(
+                MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
+                form);
+        assertTrue(response.isProfile());
+        assertTrue(response.isInUserSpace());
+        ProfileDescription profileDesc = (ProfileDescription) response
+                .getDescription();
+        assertNotNull(profileDesc);
+        assertEquals("Test1", profileDesc.getName());
+        assertEquals("My Test", profileDesc.getDescription());
+        assertEquals(expectedUserId("JUnit@test.com"), profileDesc.getUserId());
+        assertEquals("Database test user", profileDesc.getCreatorName());
+        assertTrue(profileDesc.getId().startsWith(
+                ComponentRegistry.REGISTRY_ID + "p_"));
+        assertNotNull(profileDesc.getRegistrationDate());
+        assertEquals(
+                "http://localhost:9998/registry/profiles/"
+                + profileDesc.getId(),
+                profileDesc.getHref());
+
+        profiles = getUserProfiles();
+        assertEquals(2, profiles.size());
+        assertEquals(2, getPublicProfiles().size());
+
+        // Try to post unauthenticated
+        ClientResponse cResponse = getResource().path("/registry/profiles")
+                .type(MediaType.MULTIPART_FORM_DATA)
+                .post(ClientResponse.class, form);
+        assertEquals(401, cResponse.getStatus());
+
+
+
+        CMDComponentSpec spec = getAuthenticatedResource(getResource().path("/registry/profiles/" + profileDesc.getId())
+                .queryParam(REGISTRY_SPACE_PARAM, "private")).accept(
+                MediaType.APPLICATION_XML).get(CMDComponentSpec.class);
+        assertNotNull(spec);
+
+        cResponse = this.getAuthenticatedResource(getResource()
+                .path("/registry/profiles/" + profileDesc.getId() + "/xsd"))
+                .accept(MediaType.TEXT_XML).get(ClientResponse.class);
+        assertEquals(200, cResponse.getStatus());
+        String profile = cResponse.getEntity(String.class);
+        assertTrue(profile.length() > 0);
+
+        profile = getAuthenticatedResource(getResource().path(
+                "/registry/profiles/" + profileDesc.getId() + "/xml"))
+                .accept(MediaType.TEXT_XML).get(String.class);
+        assertTrue(profile.length() > 0);
+
+        cResponse = getAuthenticatedResource(getResource().path("/registry/profiles/" + profileDesc.getId())
+                .queryParam(REGISTRY_SPACE_PARAM, "private")).delete(
+                ClientResponse.class);
+        assertEquals(200, cResponse.getStatus());
+
+        profiles = getUserProfiles();
+        assertEquals(1, profiles.size());
     }
 
     private List<ProfileDescription> getPublicProfiles() {
-	return getAuthenticatedResource("/registry/profiles").accept(
-		MediaType.APPLICATION_XML).get(PROFILE_LIST_GENERICTYPE);
+        return getAuthenticatedResource("/registry/profiles").accept(
+                MediaType.APPLICATION_XML).get(PROFILE_LIST_GENERICTYPE);
     }
 
     private List<ProfileDescription> getUserProfiles() {
-	return getAuthenticatedResource(getResource().path("/registry/profiles").queryParam(
-			REGISTRY_SPACE_PARAM, "private")).accept(
-		MediaType.APPLICATION_XML).get(PROFILE_LIST_GENERICTYPE);
+        return getAuthenticatedResource(getResource().path("/registry/profiles").queryParam(
+                REGISTRY_SPACE_PARAM, "private")).accept(
+                MediaType.APPLICATION_XML).get(PROFILE_LIST_GENERICTYPE);
     }
 
     private FormDataMultiPart createFormData(Object content) {
-	return createFormData(content, "My Test");
+        return createFormData(content, "My Test");
     }
 
     private FormDataMultiPart createFormData(Object content, String description) {
-	FormDataMultiPart form = new FormDataMultiPart();
-	form.field(IComponentRegistryRestService.DATA_FORM_FIELD, content,
-		MediaType.APPLICATION_OCTET_STREAM_TYPE);
-	form.field(IComponentRegistryRestService.NAME_FORM_FIELD, "Test1");
-	form.field(IComponentRegistryRestService.DESCRIPTION_FORM_FIELD,
-		description);
-	form.field(IComponentRegistryRestService.DOMAIN_FORM_FIELD, "My domain");
-	form.field(IComponentRegistryRestService.GROUP_FORM_FIELD, "TestGroup");
-	return form;
+        FormDataMultiPart form = new FormDataMultiPart();
+        form.field(IComponentRegistryRestService.DATA_FORM_FIELD, content,
+                MediaType.APPLICATION_OCTET_STREAM_TYPE);
+        form.field(IComponentRegistryRestService.NAME_FORM_FIELD, "Test1");
+        form.field(IComponentRegistryRestService.DESCRIPTION_FORM_FIELD,
+                description);
+        form.field(IComponentRegistryRestService.DOMAIN_FORM_FIELD, "My domain");
+        form.field(IComponentRegistryRestService.GROUP_FORM_FIELD, "TestGroup");
+        return form;
     }
 
     @Test
     public void testRegisterWithUserComponents() throws Exception {
+
+        System.out.println("testRegisterWithUserComponents");
+
         fillUpPrivateItems();
-        
+
         // kid component, not public
-	String content = "";
-	content += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
-	content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
-	content += "    <Header/>\n";
-	content += "    <CMD_Component name=\"XXX\" CardinalityMin=\"1\" CardinalityMax=\"10\">\n";
-	content += "        <CMD_Element name=\"Availability\" ValueScheme=\"string\" />\n";
-	content += "    </CMD_Component>\n";
-	content += "</CMD_ComponentSpec>\n";
-	ComponentDescription compDesc1 = RegistryTestHelper.addComponent(
-		baseRegistry, "XXX1", content, false);
+        String content = "";
+        content += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
+        content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
+        content += "    <Header/>\n";
+        content += "    <CMD_Component name=\"XXX\" CardinalityMin=\"1\" CardinalityMax=\"10\">\n";
+        content += "        <CMD_Element name=\"Availability\" ValueScheme=\"string\" />\n";
+        content += "    </CMD_Component>\n";
+        content += "</CMD_ComponentSpec>\n";
+        ComponentDescription compDesc1 = RegistryTestHelper.addComponent(
+                baseRegistry, "XXX1", content, false);
 
         // a containing component, referring to the kid (which is not public, so the containing component cannot be registered
-	content = "";
-	content += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
-	content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
-	content += "    <Header/>\n";
-	content += "    <CMD_Component name=\"YYY\" CardinalityMin=\"1\" CardinalityMax=\"unbounded\">\n";
-	content += "        <CMD_Component ComponentId=\"" + compDesc1.getId()
-		+ "\" CardinalityMin=\"0\" CardinalityMax=\"99\">\n";
-	content += "        </CMD_Component>\n";
-	content += "    </CMD_Component>\n";
-	content += "</CMD_ComponentSpec>\n";
-	FormDataMultiPart form = createFormData(content);
-	RegisterResponse response = getAuthenticatedResource(
-		"/registry/components").type(MediaType.MULTIPART_FORM_DATA)
-		.post(RegisterResponse.class, form);
+        content = "";
+        content += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
+        content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
+        content += "    <Header/>\n";
+        content += "    <CMD_Component name=\"YYY\" CardinalityMin=\"1\" CardinalityMax=\"unbounded\">\n";
+        content += "        <CMD_Component ComponentId=\"" + compDesc1.getId()
+                + "\" CardinalityMin=\"0\" CardinalityMax=\"99\">\n";
+        content += "        </CMD_Component>\n";
+        content += "    </CMD_Component>\n";
+        content += "</CMD_ComponentSpec>\n";
+        FormDataMultiPart form = createFormData(content);
+        RegisterResponse response = getAuthenticatedResource(
+                "/registry/components").type(MediaType.MULTIPART_FORM_DATA)
+                .post(RegisterResponse.class, form);
         // we first alway register in a private space, so reference to a private component should work
-	assertTrue(response.isRegistered());
+        assertTrue(response.isRegistered());
 
 
         /// profiles ///
-	content = "";
-	content += "<CMD_ComponentSpec isProfile=\"true\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
-	content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
-	content += "    <Header/>\n";
-	content += "    <CMD_Component name=\"ZZZ\" CardinalityMin=\"1\" CardinalityMax=\"unbounded\">\n";
-	content += "        <CMD_Component ComponentId=\"" + compDesc1.getId()
-		+ "\" CardinalityMin=\"0\" CardinalityMax=\"99\">\n";
-	content += "        </CMD_Component>\n";
-	content += "    </CMD_Component>\n";
-	content += "</CMD_ComponentSpec>\n";
-
-	form = createFormData(content);
-	response = getAuthenticatedResource("/registry/profiles").type(
-		MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
-		form);
-	assertTrue(response.isRegistered());
+        content = "";
+        content += "<CMD_ComponentSpec isProfile=\"true\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
+        content += "    xsi:noNamespaceSchemaLocation=\"general-component-schema.xsd\">\n";
+        content += "    <Header/>\n";
+        content += "    <CMD_Component name=\"ZZZ\" CardinalityMin=\"1\" CardinalityMax=\"unbounded\">\n";
+        content += "        <CMD_Component ComponentId=\"" + compDesc1.getId()
+                + "\" CardinalityMin=\"0\" CardinalityMax=\"99\">\n";
+        content += "        </CMD_Component>\n";
+        content += "    </CMD_Component>\n";
+        content += "</CMD_ComponentSpec>\n";
+
+        form = createFormData(content);
+        response = getAuthenticatedResource("/registry/profiles").type(
+                MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
+                form);
+        assertTrue(response.isRegistered());
 
     }
@@ -1078,123 +1134,128 @@
     @Test
     public void testRegisterUserspaceComponent() throws Exception {
-        
+
+        System.out.println("testREgisterUserspaceComponent");
+
         fillUpPrivateItems();
-        
-	List<ComponentDescription> components = getUserComponents();
-	assertEquals("user registered components", 1, components.size());
-	assertEquals("public registered components", 0, getPublicComponents()
-		.size());
-	FormDataMultiPart form = createFormData(RegistryTestHelper
-		.getComponentTestContent());
-
-	RegisterResponse response = getAuthenticatedResource(getResource().path("/registry/components")).type(
-		MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
-		form);
-	assertTrue(response.isRegistered());
-	assertFalse(response.isProfile());
-	assertTrue(response.isInUserSpace());
-	ComponentDescription desc = (ComponentDescription) response
-		.getDescription();
-	assertNotNull(desc);
-	assertEquals("Test1", desc.getName());
-	assertEquals("My Test", desc.getDescription());
-	assertEquals(expectedUserId("JUnit@test.com"), desc.getUserId());
-	assertEquals("Database test user", desc.getCreatorName());
-	assertEquals("TestGroup", desc.getGroupName());
-	assertTrue(desc.getId()
-		.startsWith(ComponentRegistry.REGISTRY_ID + "c_"));
-	assertNotNull(desc.getRegistrationDate());
-	String url = getResource().getUriBuilder().build().toString();
-	assertEquals(url + "registry/components/" + desc.getId(), desc.getHref());
-
-	components = getUserComponents();
-	assertEquals(2, components.size());
-	assertEquals(0, getPublicComponents().size());
-
-	// Try to post unauthenticated
-	ClientResponse cResponse = getResource().path("/registry/components")
-		.type(MediaType.MULTIPART_FORM_DATA)
-		.post(ClientResponse.class, form);
-	assertEquals(401, cResponse.getStatus());
-
-	// Try to get 
-	cResponse = this.getAuthenticatedResource(getResource().path("/registry/components/" + desc.getId()))
-		.accept(MediaType.APPLICATION_XML).get(ClientResponse.class);
-	
-	assertEquals(200, cResponse.getStatus());
-	CMDComponentSpec spec = getUserComponent(desc);
-	assertNotNull(spec);
-
-	cResponse = this.getAuthenticatedResource(getResource()
-		.path("/registry/components/" + desc.getId() + "/xsd"))
-		.accept(MediaType.TEXT_XML).get(ClientResponse.class);
-	assertEquals(200, cResponse.getStatus());
-	String result = cResponse.getEntity(String.class);
-	assertTrue(result.length() > 0);
-
-	result = getAuthenticatedResource(getResource().path(
-			"/registry/components/" + desc.getId() + "/xml"))
-		.accept(MediaType.TEXT_XML).get(String.class);
-	assertTrue(result.length() > 0);
-
-	cResponse = getAuthenticatedResource(getResource().path("/registry/components/" + desc.getId())).delete(
-		ClientResponse.class);
-	assertEquals(200, cResponse.getStatus());
-
-	components = getUserComponents();
-	assertEquals(1, components.size());
+
+        List<ComponentDescription> components = getUserComponents();
+        assertEquals("user registered components", 1, components.size());
+        assertEquals("public registered components", 0, getPublicComponents()
+                .size());
+        FormDataMultiPart form = createFormData(RegistryTestHelper
+                .getComponentTestContent());
+
+        RegisterResponse response = getAuthenticatedResource(getResource().path("/registry/components")).type(
+                MediaType.MULTIPART_FORM_DATA).post(RegisterResponse.class,
+                form);
+        assertTrue(response.isRegistered());
+        assertFalse(response.isProfile());
+        assertTrue(response.isInUserSpace());
+        ComponentDescription desc = (ComponentDescription) response
+                .getDescription();
+        assertNotNull(desc);
+        assertEquals("Test1", desc.getName());
+        assertEquals("My Test", desc.getDescription());
+        assertEquals(expectedUserId("JUnit@test.com"), desc.getUserId());
+        assertEquals("Database test user", desc.getCreatorName());
+        assertEquals("TestGroup", desc.getGroupName());
+        assertTrue(desc.getId()
+                .startsWith(ComponentRegistry.REGISTRY_ID + "c_"));
+        assertNotNull(desc.getRegistrationDate());
+        String url = getResource().getUriBuilder().build().toString();
+        assertEquals(url + "registry/components/" + desc.getId(), desc.getHref());
+
+        components = getUserComponents();
+        assertEquals(2, components.size());
+        assertEquals(0, getPublicComponents().size());
+
+        // Try to post unauthenticated
+        ClientResponse cResponse = getResource().path("/registry/components")
+                .type(MediaType.MULTIPART_FORM_DATA)
+                .post(ClientResponse.class, form);
+        assertEquals(401, cResponse.getStatus());
+
+        // Try to get 
+        cResponse = this.getAuthenticatedResource(getResource().path("/registry/components/" + desc.getId()))
+                .accept(MediaType.APPLICATION_XML).get(ClientResponse.class);
+
+        assertEquals(200, cResponse.getStatus());
+        CMDComponentSpec spec = getUserComponent(desc);
+        assertNotNull(spec);
+
+        cResponse = this.getAuthenticatedResource(getResource()
+                .path("/registry/components/" + desc.getId() + "/xsd"))
+                .accept(MediaType.TEXT_XML).get(ClientResponse.class);
+        assertEquals(200, cResponse.getStatus());
+        String result = cResponse.getEntity(String.class);
+        assertTrue(result.length() > 0);
+
+        result = getAuthenticatedResource(getResource().path(
+                "/registry/components/" + desc.getId() + "/xml"))
+                .accept(MediaType.TEXT_XML).get(String.class);
+        assertTrue(result.length() > 0);
+
+        cResponse = getAuthenticatedResource(getResource().path("/registry/components/" + desc.getId())).delete(
+                ClientResponse.class);
+        assertEquals(200, cResponse.getStatus());
+
+        components = getUserComponents();
+        assertEquals(1, components.size());
     }
 //
+
     @Test
     public void testCreatePrivateComponentWithRecursion() throws Exception {
-        
+
+        System.out.println("testCreatePrivateComponentWithRecursion");
+
         fillUpPrivateItems();
-	// Create new componet
-	FormDataMultiPart form = createFormData(RegistryTestHelper
-		.getComponentTestContent());
-	ClientResponse cResponse = getAuthenticatedResource(getResource().path("/registry/components")).type(
-		MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
-	assertEquals(ClientResponse.Status.OK.getStatusCode(),
-		cResponse.getStatus());
-	RegisterResponse response = cResponse.getEntity(RegisterResponse.class);
-	assertTrue(response.isRegistered());
-	ComponentDescription desc = (ComponentDescription) response
-		.getDescription();
-
-	// Re-define with self-recursion
-	String compContent = "";
-	compContent += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
-	compContent += "\n";
-	compContent += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
-	compContent += "    xsi:noNamespaceSchemaLocation=\"../../general-component-schema.xsd\">\n";
-	compContent += "    \n";
-	compContent += "    <Header/>\n";
-	compContent += "    \n";
-	compContent += "    <CMD_Component name=\"Nested\" CardinalityMin=\"1\" CardinalityMax=\"1\">\n";
-	compContent += "        <CMD_Element name=\"Availability\" ValueScheme=\"string\" />\n";
-	compContent += "        <CMD_Component ComponentId=\""
-		+ desc.getId()
-		+ "\" name=\"Recursive\" CardinalityMin=\"1\" CardinalityMax=\"1\" />\n";
-	compContent += "    </CMD_Component>\n";
-	compContent += "\n";
-	compContent += "</CMD_ComponentSpec>\n";
-
-	// Update component
-	form = createFormData(
-		RegistryTestHelper.getComponentContentAsStream(compContent),
-		"UPDATE DESCRIPTION!");
-	cResponse = getAuthenticatedResource(getResource().path(
-			"/registry/components/" + desc.getId() + "/update")).type(
-		MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
-	assertEquals(ClientResponse.Status.OK.getStatusCode(),
-		cResponse.getStatus());
-	response = cResponse.getEntity(RegisterResponse.class);
-	assertFalse("Recursive definition should fail", response.isRegistered());
-	assertEquals("There should be an error message for the recursion", 1,
-		response.getErrors().size());
-	assertTrue(
-		"There error message should specify the point of recursion",
-		response.getErrors().get(0)
-			.contains("already contains " + desc.getId()));
+        // Create new componet
+        FormDataMultiPart form = createFormData(RegistryTestHelper
+                .getComponentTestContent());
+        ClientResponse cResponse = getAuthenticatedResource(getResource().path("/registry/components")).type(
+                MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
+        assertEquals(ClientResponse.Status.OK.getStatusCode(),
+                cResponse.getStatus());
+        RegisterResponse response = cResponse.getEntity(RegisterResponse.class);
+        assertTrue(response.isRegistered());
+        ComponentDescription desc = (ComponentDescription) response
+                .getDescription();
+
+        // Re-define with self-recursion
+        String compContent = "";
+        compContent += "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
+        compContent += "\n";
+        compContent += "<CMD_ComponentSpec isProfile=\"false\" xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n";
+        compContent += "    xsi:noNamespaceSchemaLocation=\"../../general-component-schema.xsd\">\n";
+        compContent += "    \n";
+        compContent += "    <Header/>\n";
+        compContent += "    \n";
+        compContent += "    <CMD_Component name=\"Nested\" CardinalityMin=\"1\" CardinalityMax=\"1\">\n";
+        compContent += "        <CMD_Element name=\"Availability\" ValueScheme=\"string\" />\n";
+        compContent += "        <CMD_Component ComponentId=\""
+                + desc.getId()
+                + "\" name=\"Recursive\" CardinalityMin=\"1\" CardinalityMax=\"1\" />\n";
+        compContent += "    </CMD_Component>\n";
+        compContent += "\n";
+        compContent += "</CMD_ComponentSpec>\n";
+
+        // Update component
+        form = createFormData(
+                RegistryTestHelper.getComponentContentAsStream(compContent),
+                "UPDATE DESCRIPTION!");
+        cResponse = getAuthenticatedResource(getResource().path(
+                "/registry/components/" + desc.getId() + "/update")).type(
+                MediaType.MULTIPART_FORM_DATA).post(ClientResponse.class, form);
+        assertEquals(ClientResponse.Status.OK.getStatusCode(),
+                cResponse.getStatus());
+        response = cResponse.getEntity(RegisterResponse.class);
+        assertFalse("Recursive definition should fail", response.isRegistered());
+        assertEquals("There should be an error message for the recursion", 1,
+                response.getErrors().size());
+        assertTrue(
+                "There error message should specify the point of recursion",
+                response.getErrors().get(0)
+                .contains("already contains " + desc.getId()));
 
     }
